DECLARE 
    -- test_30.sql
    v_fileHandle            utl_file.FILE_TYPE;

    r_alignment             xml_spreadsheet.t_rec_alignment;
    r_customStyles          xml_spreadsheet.t_rec_customStyles;
    
    tab_customStyles        xml_spreadsheet.t_tab_customStyles;

BEGIN
	-- vertical
    r_customStyles.id           := 's50';
    r_customStyles.type         := 'Text';
    r_alignment.vertical        := 'Top';
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(1)         := r_customStyles;

    r_customStyles.id           := 's51';
    r_alignment.vertical        := 'Bottom';
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(2)         := r_customStyles;

    r_customStyles.id           := 's52';
    r_alignment.vertical        := 'Center';
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(3)         := r_customStyles;
    -- Reset Style to default because record is used for further styles
    r_alignment.vertical        := NULL;

    -- horizontal
    r_customStyles.id           := 's53';
    r_alignment.horizontal      := 'Left';
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(4)         := r_customStyles;
    
    r_customStyles.id           := 's54';
    r_alignment.horizontal      := 'Center';
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(5)         := r_customStyles;

    r_customStyles.id           := 's55';
    r_alignment.horizontal      := 'Right';
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(6)         := r_customStyles;

    r_customStyles.id           := 's56';
    r_alignment.horizontal      := 'Justify';
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(7)         := r_customStyles;

    r_customStyles.id           := 's57';
    r_alignment.horizontal      := 'Fill';
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(8)         := r_customStyles;
    r_alignment.horizontal      := NULL;
    
    -- text rotate
    r_customStyles.id           := 's58';
    r_alignment.textRotate      := 15;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(9)         := r_customStyles;

    r_customStyles.id           := 's59';
    r_alignment.textRotate      := 30;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(10)        := r_customStyles;

    r_customStyles.id           := 's60';
    r_alignment.textRotate      := 45;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(11)        := r_customStyles;

    r_customStyles.id           := 's61';
    r_alignment.textRotate      := -15;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(12)        := r_customStyles;
    r_alignment.textRotate      := NULL;

    -- Wrap text
    r_customStyles.id           := 's62';
    r_alignment.wrapText        := TRUE;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(13)        := r_customStyles;

    r_customStyles.id           := 's63';
    r_alignment.wrapText        := FALSE;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(14)        := r_customStyles;

    r_customStyles.id           := 's64';
    r_alignment.wrapText        := NULL;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(15)        := r_customStyles;

    r_customStyles.id           := 's65';
    r_alignment.verticalText    := TRUE;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(16)        := r_customStyles;

    r_customStyles.id           := 's66';
    r_alignment.verticalText    := FALSE;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(17)        := r_customStyles;

    r_customStyles.id           := 's67';
    r_alignment.verticalText    := NULL;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(18)        := r_customStyles;

    r_customStyles.id           := 's68';
    r_alignment.shrinkToFit     := TRUE;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(19)        := r_customStyles;

    r_customStyles.id           := 's69';
    r_alignment.shrinkToFit     := TRUE;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(20)        := r_customStyles;

    r_customStyles.id           := 's70';
    r_alignment.shrinkToFit     := TRUE;
    r_customStyles.alignment    := r_alignment;
    tab_customStyles(21)        := r_customStyles;

    -- New File
    v_fileHandle   := xml_spreadsheet.createNewFile('DOC','test_30.xml',tab_customStyles);
    -- open first worksheet
    xml_spreadsheet.newWorksheet(
             v_fileHandle
            ,'Alignment'
            );

    -- Write a data row
    xml_spreadsheet.writeData(v_fileHandle,'Vertical alignment',xml_spreadsheet.c_textBold);
    xml_spreadsheet.writeData(v_fileHandle,'Top','s50');
    xml_spreadsheet.writeData(v_fileHandle,'Bottom','s51');
    xml_spreadsheet.writeData(v_fileHandle,'Center','s52');
    -- New data row
    xml_spreadsheet.newDatarow(v_fileHandle);
    xml_spreadsheet.writeData(v_fileHandle,'Horizontal alignment',xml_spreadsheet.c_textBold);
    xml_spreadsheet.writeData(v_fileHandle,'Left','s53');
    xml_spreadsheet.writeData(v_fileHandle,'Center','s54');
    xml_spreadsheet.writeData(v_fileHandle,'Right','s55');
    xml_spreadsheet.writeData(v_fileHandle,'Justify','s56');
    xml_spreadsheet.writeData(v_fileHandle,'Fill','s57');
    -- New data row
    xml_spreadsheet.newDatarow(v_fileHandle);
    xml_spreadsheet.writeData(v_fileHandle,'Rotate',xml_spreadsheet.c_textBold);
    xml_spreadsheet.writeData(v_fileHandle,'15','s58');
    xml_spreadsheet.writeData(v_fileHandle,'30','s59');
    xml_spreadsheet.writeData(v_fileHandle,'45','s60');
    xml_spreadsheet.writeData(v_fileHandle,'-15','s61');
    -- New data row
    xml_spreadsheet.newDatarow(v_fileHandle);
    xml_spreadsheet.writeData(v_fileHandle,'Wrap Text',xml_spreadsheet.c_textBold);
    xml_spreadsheet.writeData(v_fileHandle,'This text should wrap','s62');
    xml_spreadsheet.writeData(v_fileHandle,'This text should not wrap','s63');
    xml_spreadsheet.writeData(v_fileHandle,'Default for text wrap','s64');
    -- New data row
    xml_spreadsheet.newDatarow(v_fileHandle);
    xml_spreadsheet.writeData(v_fileHandle,'Vertical Text',xml_spreadsheet.c_textBold);
    xml_spreadsheet.writeData(v_fileHandle,'Yes','s65');
    xml_spreadsheet.writeData(v_fileHandle,'No','s66');
    xml_spreadsheet.writeData(v_fileHandle,'Default','s67');
    -- New data row
    xml_spreadsheet.newDatarow(v_fileHandle);
    xml_spreadsheet.writeData(v_fileHandle,'Shrink to fit',xml_spreadsheet.c_textBold);
    xml_spreadsheet.writeData(v_fileHandle,'Yes And I need quite a long text to show the effect','s68');
    xml_spreadsheet.writeData(v_fileHandle,'No','s69');
    xml_spreadsheet.writeData(v_fileHandle,'Default','s70');
    -- close worksheet
    xml_spreadsheet.closeWorksheet(
             v_fileHandle
            ,0 -- fix no rows in first worksheet when scrolling
            );

    -- Close file
    xml_spreadsheet.closeFile(v_fileHandle);

END;
/
